(function () {
    
    var osGallery = function (container, params) {
        if (!(this instanceof osGallery)) return new osGallery(container, params);

        var defaults = {
            minImgEnable : 1,
            spaceBetween: 2.5,
            minImgSize: 200,
            numColumns: 3,
            showImgTitle: '',
            showImgDescription: '',
            limEnd: 5,
            galId: 1,
            galIdRandom: 1,
            imgCountCat: '',
            load_more_background: '',
            os_fancybox_background: '',
            showLoadMore: '',
            juri: '',
            itemId: '',
            layout: 'default',
            albumSublayout: 'defaultTabs',
            modId: 0,
            searchText: '',
            fancSettings:{
                wrapCSS: 'os-os_fancybox-window',
                animationEffect: false,
                animationDuration: '500',
                transitionEffect: false,
                transitionDuration: '800',
                loop: false,
                arrows: true,
                clickContent: 'zoom',
                wheel : false,
                slideShow : {
                    autoStart : false,
                    speed     : 4000
                },
                clickSlide : 'close',
                thumbs : {
                    autoStart : true,
                    axis : 'y'
                },
                buttons : [
                'slideShow',
                'fullScreen',
                'thumbs',
                'share',
                'download',
                'zoom',
                'arrowLeft',
                'arrowRight',
                'close'
                ],
                share : {
                    tpl : ''
                },
                infobar : true,
                baseClass : 'thumb_right'
            }
        };

        for (var param in defaults) {
          if (!params[param] && params[param] != 0){
            params[param] = defaults[param];
          }
        }
        // gallery settings
        var osg = this;
        // Params
        osg.params = params || defaults;
        
        osg.getImgBlockWidth = function (numColumns){
            if(typeof(numColumns) == 'undefined')numColumns = osg.params.numColumns;
            var checkSpaceBetween = osg.params.spaceBetween;
            spaceBetween = osg.params.spaceBetween*2;
            mainBlockW = jQuerOs(container).width();
            
            if(osg.params.layout == 'masonry' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'masonry')){
                
                var percentGridSizer = 100/numColumns;
                var gridSizer = mainBlockW/numColumns;
                imgBlockWpx = (mainBlockW - (spaceBetween*numColumns))/numColumns;
                imgBlockW = percentGridSizer * imgBlockWpx/gridSizer - 0.25;

                if(!checkSpaceBetween) imgBlockW = percentGridSizer;

                jQuerOs(".grid-sizer-"+osg.params.galIdRandom).css('width', percentGridSizer + "%");
                jQuerOs("#grid-"+osg.params.galIdRandom).css('width', imgBlockW + "%");
                var sizeAwesome = ((imgBlockW*mainBlockW)/100)/11+"px";
                jQuerOs(container +" .andrea-effect .andrea-zoom-in").css({'width': sizeAwesome, 'height': sizeAwesome });

                var fontSizetext = ((imgBlockW*mainBlockW)/100)/15+"px";
                jQuerOs(container +" .grid-item").css({'font-size': fontSizetext, 'line-height': fontSizetext });
                if(osg.params.minImgEnable){
                    if( ((imgBlockW*mainBlockW)/100) < osg.params.minImgSize ){
                        numColumns--;
                        osg.getImgBlockWidth(numColumns);
                    }
                }

                return imgBlockW;
            }else if(osg.params.layout == 'fitRows' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'fit_rows')){
                
                imgBlockK = 1 / numColumns;
                var images = jQuerOs("#grid-item-"+osg.params.galIdRandom);
                
                jQuerOs.each(images, function(){
                    var img = jQuerOs(this).find("img");
                    var w_ = jQuerOs(img).prop('naturalWidth');
                    var h_ = jQuerOs(img).prop('naturalHeight');

                    w_ = w_ * imgBlockK;
                    h_ =  h_ * imgBlockK ;
                    
                    img.css('width', w_ + "px");
//                    jQuerOs(this).css('width', w_ + "px");
                    img.css('height', h_ + "px");
//                    jQuerOs(this).css('height', h_ + "px");

                }); 
                
                spaceBetween = osg.params.spaceBetween*2;
                mainBlockW = jQuerOs(container).width();
                imgBlockW = ( (((mainBlockW-(spaceBetween*numColumns))/numColumns) )*100)/mainBlockW  ;

                var sizeAwesome = ((imgBlockW*mainBlockW)/100)/11+"px";
                jQuerOs(container +" .andrea-effect .andrea-zoom-in").css({'width': sizeAwesome, 'height': sizeAwesome });

                var fontSizetext = ((imgBlockW*mainBlockW)/100)/15+"px";
                jQuerOs(container +" .img-block").css({'font-size': fontSizetext, 'line-height': fontSizetext });

                jQuerOs("#gutter-sizer-"+osg.params.galIdRandom).css('width', "0%");
                jQuerOs(".os-gallery-tabs-main-"+osg.params.galIdRandom+" .os-cat-tab-images .grid .img-block").css('height', "");
                jQuerOs(".os-gallery-tabs-main-"+osg.params.galIdRandom+" .os-cat-tab-images .grid .img-block").css('width', "");
                
                var sizeAwesome = ((imgBlockW*mainBlockW)/100)/11+"px";
                jQuerOs(container +" .andrea-effect .andrea-zoom-in").css({'width': sizeAwesome, 'height': sizeAwesome });

                var fontSizetext = ((imgBlockW*mainBlockW)/100)/15+"px";
                jQuerOs(container +" .img-block").css({'font-size': fontSizetext, 'line-height': fontSizetext });
            }else{
                imgBlockW = ( (((mainBlockW-(spaceBetween*numColumns))/numColumns) )*100)/mainBlockW  ;
                if(osg.params.minImgEnable){
                    if(((imgBlockW*mainBlockW)/100) < osg.params.minImgSize){
                        numColumns--;
                        osg.getImgBlockWidth(numColumns);
                    }
                }
                var sizeAwesome = ((imgBlockW*mainBlockW)/100)/11+"px";
                jQuerOs(container +" .andrea-effect .andrea-zoom-in").css({'width': sizeAwesome, 'height': sizeAwesome });
                var fontSizetext = ((imgBlockW*mainBlockW)/100)/15+"px";
                jQuerOs(container +" .img-block").css({'font-size': fontSizetext, 'line-height': fontSizetext });

                return imgBlockW;
            }
        }
        
        osg.imageWidthCalculation = function(catId, numColumns){
            if(typeof(numColumns) == 'undefined'){
                numColumns = osg.params.numColumns;
            }
            
            var mainBlockW = jQuerOs(container).width();
            var imgBlockK = 1 / numColumns;
            //var result = [];
            var images = jQuerOs.makeArray(jQuerOs("#cat-"+ catId +"-"+osg.params.galIdRandom+" .img-block a img"));
            var images_a = jQuerOs("#cat-"+ catId +"-"+osg.params.galIdRandom+" .img-block a").find("img:first");
            images = jQuerOs.makeArray(images_a)
            
            var min = jQuerOs(images[0]).prop('naturalHeight') * imgBlockK;
            
            //var countImg = mainBlockW/min;
            //var counter = images.length;
            spaceBetween = osg.params.spaceBetween*2;

            var copyImages = images.slice();
            var arr_1 = [];
            var arr_2 = [];
            var arr_3 = [];
            var widthRows = 0;
            var k_height = 0 ;
            while(copyImages.length > 0){
                arr_1 = copyImages.splice(0, numColumns);
                //суммирование длин картинок в массиве arr_1
                for(var i = 0; i < arr_1.length; i++){
                    widthRows += (jQuerOs(arr_1[i]).prop('naturalWidth'));
                }
                var k = (mainBlockW - ((numColumns) * spaceBetween) - (numColumns) ) / (widthRows );
                if (k_height == 0 ) k_height = k ;

                //set k for last images
                if(k_height > 0 && arr_1.length < numColumns && k > k_height){
                    k = k_height;
                }
                
                

                for(var i = 0; i < arr_1.length; i++){
                    arr_2.push((jQuerOs(arr_1[i]).prop('naturalWidth')) * k);
                    arr_3.push((jQuerOs(arr_1[i]).prop('naturalHeight')) * k_height);
                }
                widthRows = 0;
                //clear array
                arr_1 = [];
            }

            var imag = jQuerOs("#cat-"+ catId +"-"+osg.params.galIdRandom+" .img-block a img");
            imag = jQuerOs("#cat-"+ catId +"-"+osg.params.galIdRandom+" .img-block a");
            var j = 0;
            
            jQuerOs.each(imag, function(){
                var img = jQuerOs(this).find("img");
                
                var w_ = arr_2[j];
                var h_ = arr_3[j];
                

                img.css('width', w_ + "px");
                jQuerOs(this).css('width', w_ + "px");
                if(osg.params.layout == 'album' && osg.params.albumSublayout == 'fit_rows'){
                    jQuerOs(this).parents('.img-block').css('width', w_ + "px");
                }
//                jQuerOs(this).parent().find(".os-gallery-caption-top").css('width', w_ + "px");
//                jQuerOs(this).parent().find(".os-gallery-caption-bottom").css('width', w_ + "px");
                jQuerOs(this).find(".os-gallery-caption-top").css('width', w_ + "px");
                jQuerOs(this).find(".os-gallery-caption-bottom").css('width', w_ + "px");
                img.css('height', h_ + "px");
                jQuerOs(this).css('height', h_ + "px");

                j++;
            });

            var imgBlockWpx = (mainBlockW - (spaceBetween*numColumns))/numColumns;
            if(osg.params.minImgEnable){
                if(((imgBlockWpx*mainBlockW)/100) < osg.params.minImgSize){
                    numColumns--;
                    osg.sortImg(catId, numColumns);
                }
            }
        }

        osg.fitRowsIsotope = function(curCatId){
            jQuerOs("#cat-"+curCatId+"-"+osg.params.galIdRandom).imagesLoaded(function(){
                osg.imageWidthCalculation(curCatId);
                jQuerOs("#cat-"+ curCatId+ "-"+osg.params.galIdRandom+" .fitrow-more-hidden").removeClass("fitrow-more-hidden");
            });
        }
        
        osg.isotope = function(){
            jQuerOs(container + ' .grid').isotope({
                itemSelector: '.grid-item',
                percentPosition: true,
                masonry: {
                    columnWidth: '#grid-sizer-'+osg.params.galIdRandom                                
                },
            });
        }

        osg.reloadIsotope = function(){
            //VlaDOS 11.01.2021 Commented out due to a jump when LoadMore images.
//            jQuerOs(container + ' .grid').isotope( 'destroy' );
            //VlaDOS 11.01.2021//
            jQuerOs(container + ' .grid').isotope();
        } 

        osg.reloadAfterLazyLoad = function(){
            jQuerOs('.grid').isotope('reloadItems');
            osg.resizeGallery();
            jQuerOs(container + ' .grid').imagesLoaded(function(){
                osg.isotope();
            });
        }

        //function reinit for load more functions
        osg.reinit = function(catId, limEnd){
                
                if(limEnd != 0) jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom+" a.active").attr('data-end', limEnd);

                if(catId){

                    jQuerOs(container+" .os-cat-tab-images div[id^='cat-']").find(".os_fancybox-"+catId ).os_fancybox({
                        beforeShow: function(){
                            // resize html block to image width
                            if (this.os_image_id){
                                var id = this.os_image_id;
                            }
                            else {
                                var id = this.opts.$orig.attr('id');
                            }
                            id = id.split('-')[1];//get scalar id
                            var naturalWidth = jQuerOs('.htmlWidthAsImage#data-html-'+id+' .imgInHtml img').prop('naturalWidth');
                            if(naturalWidth){  
                                jQuerOs('.htmlWidthAsImage#data-html-'+id).css({'padding' : 0, 'width' : naturalWidth});
                                jQuerOs('.htmlWidthAsImage#data-html-'+id+' .contentInHtml').css({'padding' : 15});
                            }
                            jQuerOs('.os_fancybox-bg').css('backgroundColor', osg.params.os_fancybox_background);

                            if (this.os_image_id){
                                var id = this.os_image_id;
                            }    
                            else {
                                var id = this.opts.$orig.attr('id');
                            }
                            var href = window.location.href;
                            if(!from_history){
                                if (href.indexOf('&os_image_id') > -1) {

                                    history.pushState (null, null, href.substring(0, href.indexOf('&os_image_id') )+ "&" + id);}
                                else if (href.indexOf('?os_image_id') > -1) {

                                    history.pushState (href, null, href.substring(0, href.indexOf('?os_image_id')) + "?" + id);}
                                else if (href.indexOf('?') > -1 && href.indexOf('&') > -1 && href.indexOf('&os_image_id') == -1){

                                    history.pushState(null, null, href + '&' + id);}
                                else if ( href.indexOf('&') == -1 && href.indexOf('?os_image_id') == -1 && href.indexOf('?') == -1){

                                    history.pushState(null, null, href + '?' + id);}
                                else if (href.indexOf('?') > -1 && href.indexOf('os_image_id') == -1 ){
                                    history.pushState(null, null, href + '&' + id);
                                }

                            }
//                                        



                        },
                        beforeClose: function(){
                            var href = window.location.href;

                            if (href.indexOf('&os_image_id') > -1){
                                history.pushState (href, null, href.substring(0, href.indexOf('&os_image_id')));
                            }else{
                                history.pushState (href, null, href.substring(0, href.indexOf('?os_image_id')));
                            }
                            //return value scroll for load more function

                            if (osg.params.showLoadMore == 'scroll'){
                                osg.loadMore(osg.params.showLoadMore);
                            }
                        },
                        beforeLoad: function() {
                            //not use because call many times for one image
                        },
                        afterShow: function() {
                            var href = window.location.href;
                            var os_fancy_box_getInst = jQuerOs.os_fancybox.getInstance();
                            //get the length of the array
                            var os_fb_group_count = os_fancy_box_getInst.group.length;
                            //get the current position
                            var os_now = os_fancy_box_getInst.currIndex;

                            var os_show_load_more = osg.params.showLoadMore;
                            //if there are less than 3 pictures left before the end of the array and if load more is possible, we call the load
                            var catId = jQuerOs('.os-cat-tab-images .active').attr('data-cat-id');
                            var data_end = jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end');
                            if(data_end == undefined){
                                data_end = 0
                            }

                            if ((Number(os_now) + 4) > os_fb_group_count && data_end > 0 && os_show_load_more !== null && os_show_load_more != 0){ 
                                


                                if (os_show_load_more == 'auto'){
                                    osg.loadMore("auto");

                                }
                                else if (os_show_load_more !== null){

                                    osg.loadMore("button");
                                    jQuerOs('#load-more-'+osg.params.galIdRandom).trigger('click');
                                }
                                jQuerOs(".os_fancybox-button--arrow_right").attr('disabled', 'true');
                                jQuerOs(".os_fancybox-button--arrow_left").attr('disabled', 'true');
                                var html = jQuerOs("<div class='os_fancybox-loading'></div>")
                                jQuerOs(".os_fancybox-slide").append(html)
                                

                            }

                            if (Number(os_now) == os_fb_group_count && jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end') > -1){
                                jQuerOs(".os_fancybox-button--arrow_right").attr('disabled', 'true');
                            }


                        },
                        afterLoad: function(){
                            //not use because call many times for one image

                        },  
                        wrapCSS    : osg.params.fancSettings.wrapCSS,

                        animationEffect : osg.params.fancSettings.animationEffect,
                        animationDuration : osg.params.fancSettings.animationDuration,
                        transitionEffect : osg.params.fancSettings.transitionEffect,
                        transitionDuration : osg.params.fancSettings.transitionDuration,
                        loop: osg.params.fancSettings.loop,
                        arrows: osg.params.fancSettings.arrows,
                        clickContent : function( current, event ) {
                            return current.type === 'image' ? osg.params.fancSettings.clickContent : false;
                        },
                        wheel : osg.params.fancSettings.wheel,
                        slideShow : {
                            autoStart : osg.params.fancSettings.slideShow.autoStart,
                            speed     : osg.params.fancSettings.slideShow.speed
                        },

                        clickSlide : osg.params.fancSettings.clickSlide,
                        thumbs : {
                            autoStart : osg.params.fancSettings.thumbs.autoStart,
                            axis      : osg.params.fancSettings.thumbs.axis
                        },
                        buttons : [
                            osg.params.fancSettings.buttons.slideShow,
                            osg.params.fancSettings.buttons.fullScreen,
                            osg.params.fancSettings.buttons.thumbs,
                            osg.params.fancSettings.buttons.share,
                            osg.params.fancSettings.buttons.download,
                            osg.params.fancSettings.buttons.zoom,
                            osg.params.fancSettings.buttons.arrowLeft,
                            osg.params.fancSettings.buttons.arrowRight,
                            osg.params.fancSettings.buttons.close,
                        ],
                        share : {
                            tpl : osg.params.fancSettings.share.tpl
                        },
                        infobar: osg.params.fancSettings.infobar, //counter on/off
                        baseClass : osg.params.fancSettings.baseClass, //add appropriate class to set thumbnails position {thumb_bottom},{thumb_right}
                        loadmore : osg.params.showLoadMore,
                    });
                }
        }


        //initialize function
        osg.init = function(limEnd){ 
            inProgressAjax = false;
            if(osg.params.juri.slice(-1) == '/'){
                osg.params.juri = osg.params.juri.slice(0, -1);
            }
            if(limEnd != 0) jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom+" a.active").attr('data-end', limEnd);

            imgBlockW = osg.getImgBlockWidth();
            
            jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom).css("padding", osg.params.spaceBetween + "px");
            jQuerOs("#button-"+osg.params.galIdRandom).css("padding", osg.params.spaceBetween + "px");
            
            if(osg.params.layout == 'default' || osg.params.layout == 'search'){
                jQuerOs(container+" .img-block").css("width",imgBlockW+"%");
            }else if(osg.params.layout == 'allInOne'){
                
                jQuerOs(container+" .all-in-one-block .img-block:first-child").css("width",imgBlockW+"%");
                jQuerOs(container+" .os-cat-tab-images").show();
            }else if(osg.params.layout == 'album'){
                if(osg.params.albumSublayout == 'fit_rows'){
                    numColumns = osg.params.numColumns
                    imgBlockW = ( (((mainBlockW-(spaceBetween*numColumns))/numColumns) )*100)/mainBlockW  ;
                    if(osg.params.minImgEnable){
                        if(((imgBlockW*mainBlockW)/100) < osg.params.minImgSize){
                            numColumns--;
                            osg.getImgBlockWidth(numColumns);
                        }
                    }
                    var sizeAwesome = ((imgBlockW*mainBlockW)/100)/11+"px";
                    jQuerOs(container +" .andrea-effect .andrea-zoom-in").css({'width': sizeAwesome, 'height': sizeAwesome });
                    var fontSizetext = ((imgBlockW*mainBlockW)/100)/15+"px";
                    jQuerOs(container +" .img-block").css({'font-size': fontSizetext, 'line-height': fontSizetext });
                }
                jQuerOs("#button-"+osg.params.galIdRandom).css("padding", osg.params.spaceBetween+'px');
                jQuerOs(container+" .album-block .img-block").css("width",imgBlockW+"%");
                jQuerOs(container+" .os-cat-tab-images").show();
                
            }else if(osg.params.layout == 'masonry'){
                jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom).css("padding", osg.params.spaceBetween+"px");
                jQuerOs("#button-"+osg.params.galIdRandom).css("padding", osg.params.spaceBetween+"px");
                jQuerOs(container+" #grid-"+osg.params.galIdRandom).css("width",imgBlockW+"%");
            }else if(osg.params.layout == 'fitRows'){
                jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom).css("padding", osg.params.spaceBetween+"px");
                jQuerOs("#button-"+osg.params.galIdRandom).css("padding", osg.params.spaceBetween+"px");
            }
            jQuerOs(container+" .os-cat-tab-images div[id^='cat-']").each(function(index, el) {

                catId = jQuerOs(this).data("cat-id");
                if(catId){

                    var os_fancy_box = jQuerOs(this).find(".os_fancybox-"+catId ).os_fancybox({



                       beforeShow: function(){

                            // resize html block to image width
                            if (this.os_image_id){
                                var id = this.os_image_id;
                            }
                            else {
                                var id = this.opts.$orig.attr('id');
                            }
                            id = id.split('-')[1];//get scalar id
                            var naturalWidth = jQuerOs('.htmlWidthAsImage#data-html-'+id+' .imgInHtml img').prop('naturalWidth');
                            if(naturalWidth){  
                                jQuerOs('.htmlWidthAsImage#data-html-'+id).css({'padding' : 0, 'width' : naturalWidth});
                                jQuerOs('.htmlWidthAsImage#data-html-'+id+' .contentInHtml').css({'padding' : 15});
                            }
                            jQuerOs('.os_fancybox-bg').css('backgroundColor', osg.params.os_fancybox_background);

                            if (this.os_image_id){
                                var id = this.os_image_id;
                            }    
                            else {
                                var id = this.opts.$orig.attr('id');
                            }

                            var href = window.location.href;

                            if(!from_history){


                                if (href.indexOf('&os_image_id') > -1) {

                                    history.pushState (null, null, href.substring(0, href.indexOf('&os_image_id') )+ "&" + id);
                                }
                                else if (href.indexOf('?os_image_id') > -1) {

                                    history.pushState (href, null, href.substring(0, href.indexOf('?os_image_id')) + "?" + id);}
                                else if (href.indexOf('?') > -1 && href.indexOf('&') > -1 && href.indexOf('&os_image_id') == -1){

                                    history.pushState(null, null, href + '&' + id);}
                                else if ( href.indexOf('&') == -1 && href.indexOf('?os_image_id') == -1 && href.indexOf('?') == -1){

                                    history.pushState(null, null, href + '?' + id);}
                                else if (href.indexOf('?') > -1 && href.indexOf('os_image_id') == -1 ){

                                    history.pushState(null, null, href + '&' + id);
                                }

                            }
//                                        
//                                       



                        },
                        beforeClose: function(){

                            var href = window.location.href;

                            if (href.indexOf('&os_image_id') > -1){
                                history.pushState (href, null, href.substring(0, href.indexOf('&os_image_id')));
                            }else{
                                history.pushState (href, null, href.substring(0, href.indexOf('?os_image_id')));
                            } 
                            //return value scroll for load more function
                            if (osg.params.showLoadMore == 'scroll'){
                                osg.loadMore(osg.params.showLoadMore);
                            }
                            jQuerOs('.os-cat-tab-images .active').removeClass('active');
                        },
                        beforeLoad: function() {
                            //not use because call many times for one image



                        },
                        afterShow: function() {

                            
                            var href = window.location.href;
                            var os_fancy_box_getInst = jQuerOs.os_fancybox.getInstance();
                            //get the length of the array
                            var os_fb_group_count = os_fancy_box_getInst.group.length;
                            //get the current position
                            var os_now = os_fancy_box_getInst.currIndex;
//                            if(os_now == undefined){
//                                var cat_id = jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-cat-id');
//                                os_now = jQuerOs("#cat-"+cat_id+"-"+osg.params.galIdRandom + " .img-block").length;
//                            } 
                            var os_show_load_more = osg.params.showLoadMore;
                            //if there are less than 3 pictures left before the end of the array and if load more is possible, we call the load
                            var catId = jQuerOs('.os-cat-tab-images .active').attr('data-cat-id');
                            var data_end = jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end');
                            if(data_end == undefined){
                                data_end = 0
                            }

                            if ((Number(os_now) + 4) > os_fb_group_count && data_end > 0  && os_show_load_more !== null && os_show_load_more != 0){ 
                                if (os_show_load_more == 'auto'){
                                    osg.loadMore("auto");

                                }
                                else if (os_show_load_more !== null){

                                    osg.loadMore("button");
                                    jQuerOs('#load-more-'+osg.params.galIdRandom).trigger('click');
                                }
                                jQuerOs(".os_fancybox-button--arrow_right").attr('disabled', 'true');
                                jQuerOs(".os_fancybox-button--arrow_left").attr('disabled', 'true');
                                var html = jQuerOs("<div class='os_fancybox-loading'></div>")
                                jQuerOs(".os_fancybox-slide").append(html)
                                

                            }

                            if (Number(os_now) == os_fb_group_count && jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end') > -1){
                                jQuerOs(".os_fancybox-button--arrow_right").attr('disabled', 'true');
                            }


                        },
                        afterLoad: function(){
                            //not use because call many times for one image
                        },        


                        wrapCSS    : osg.params.fancSettings.wrapCSS,

                        animationEffect : osg.params.fancSettings.animationEffect,
                        animationDuration : osg.params.fancSettings.animationDuration,
                        transitionEffect : osg.params.fancSettings.transitionEffect,
                        transitionDuration : osg.params.fancSettings.transitionDuration,
                        loop: osg.params.fancSettings.loop,
                        arrows: osg.params.fancSettings.arrows,
                        clickContent : function( current, event ) {
                            return current.type === 'image' ? osg.params.fancSettings.clickContent : false;
                        },
                        wheel : osg.params.fancSettings.wheel,
                        slideShow : {
                            autoStart : osg.params.fancSettings.slideShow.autoStart,
                            speed     : osg.params.fancSettings.slideShow.speed
                        },

                        clickSlide : osg.params.fancSettings.clickSlide,
                        thumbs : {
                            autoStart : osg.params.fancSettings.thumbs.autoStart,
                            axis      : osg.params.fancSettings.thumbs.axis
                        },
                        buttons : [
                            osg.params.fancSettings.buttons.slideShow,
                            osg.params.fancSettings.buttons.fullScreen,
                            osg.params.fancSettings.buttons.thumbs,
                            osg.params.fancSettings.buttons.share,
                            osg.params.fancSettings.buttons.download,
                            osg.params.fancSettings.buttons.zoom,
                            osg.params.fancSettings.buttons.arrowLeft,
                            osg.params.fancSettings.buttons.arrowRight,
                            osg.params.fancSettings.buttons.close,
                        ],
                        share : {
                            tpl : osg.params.fancSettings.share.tpl
                        },
                        infobar: osg.params.fancSettings.infobar, //counter on/off
                        baseClass : osg.params.fancSettings.baseClass, //add appropriate class to set thumbnails position {thumb_bottom},{thumb_right}
                        loadmore : osg.params.showLoadMore,

                    });
                }
            });
            width = jQuerOs(window).width();
            if(osg.params.layout == 'album'){
                jQuerOs(container+" .album-main-image").click(function(event) {
                            
                    //osg.loadMore("auto", limEnd);
                    albumId = jQuerOs(this).data("cat-id");
                    var href = window.location.href;
                    if (!from_history && href.indexOf('os_image_id') == -1){
                        if (href.indexOf('?cat-') > -1) {

                            history.pushState (null, null, href.substring(0, href.indexOf('?cat-') ) + '?cat-' + albumId);
                        }else if (href.indexOf('&cat-') > -1) {

                            history.pushState (null, null, href.substring(0, href.indexOf('&cat-') ) + '?cat-' + albumId);
                        }else if (href.indexOf('?') > -1){

                            history.pushState(null, null, href + '&cat-' + albumId);
                        }else {

                            history.pushState(null, null, href + '?cat-' + albumId);
                        }
                    }
                    
                    jQuerOs("#back-"+osg.params.galIdRandom).css("margin", osg.params.spaceBetween +"px");
                    curCatId = jQuerOs("#cat-"+albumId+"-"+osg.params.galIdRandom).attr('data-cat-id');
                    jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-cat-id', curCatId);

                    var curEnd = jQuerOs("#cat-"+albumId+"-"+osg.params.galIdRandom).attr('data-end');


                    jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end', curEnd);

                    jQuerOs(container+" .back-to-albums").data("cat-id", albumId);
                    //show album
                    jQuerOs(container+" .os-gallery-album-"+albumId).parent().fadeTo( "slow", 1 );
                    jQuerOs(container+" .os-gallery-album-"+albumId+","+container+" .back-to-albums").fadeTo( "slow", 1 );

                    if(osg.params.showLoadMore == 'button'){
                        jQuerOs("#load-more-"+osg.params.galIdRandom).fadeTo( "slow", 1 );
                    }
                    
                    //hide albums main image
                    jQuerOs(container+" .album-main-image").parent().hide();

                    jQuerOs("#cat-"+albumId+"-"+osg.params.galIdRandom+" .grid").show();
                    jQuerOs("#cat-"+albumId+"-"+osg.params.galIdRandom+" .img-block:not(:first)").show();
                    window.stopAlbum = true;
                    osg.loadMore(osg.params.showLoadMore,true);
                    if(osg.params.imgCountCat != ''){
                        var img_count_cat = JSON.parse(osg.params.imgCountCat);
                    }else{
                        var img_count_cat = '';
                    }

                    if(img_count_cat != '' && (jQuerOs('#cat-' + curCatId +'-'+osg.params.galIdRandom).children().length - 1) >= Number(img_count_cat[curCatId])){

                        jQuerOs("#load-more-"+osg.params.galIdRandom+"[data-cat-id="+curCatId+"]").hide();

                    }else{

                        jQuerOs("#load-more-"+osg.params.galIdRandom+"[data-cat-id="+curCatId+"]").show();
                    }
                    if(curEnd != -1){
                        jQuerOs("#load-more-"+osg.params.galIdRandom).removeAttr("disabled");
                        jQuerOs("#load-more-"+osg.params.galIdRandom).css("background", osg.params.load_more_background);
                    }
                    if(osg.params.albumSublayout == 'masonry'){
                        osg.reloadIsotope();
                    }else if(osg.params.albumSublayout == 'fit_rows'){
                        osg.resizeGallery();
                        osg.fitRowsIsotope(curCatId);
                    }

                    

                });
                
                jQuerOs(container+" .back-to-albums").unbind('click');
                jQuerOs(container+" .back-to-albums").click(function(event) {
                    //hide images
                    albumId = jQuerOs(this).data("cat-id");
                    var href = window.location.href;

                    if (href.indexOf('&cat-') > -1){

                        history.pushState (href, null, href.substring(0, href.indexOf('&cat-')));
                    }else if (href.indexOf('?cat-') > -1){

                        history.pushState (href, null, href.substring(0, href.indexOf('?cat-')));
                    }

                    jQuerOs(container+" .os-gallery-album-"+albumId).parent().hide();
                    jQuerOs(container+" .os-gallery-album-"+albumId+","+container+" .back-to-albums").hide();
                    jQuerOs("#cat-"+albumId+"-"+osg.params.galIdRandom+" .img-block").hide();
                    jQuerOs("#cat-"+albumId+"-"+osg.params.galIdRandom+" .grid").hide();
                    jQuerOs("#load-more-"+osg.params.galIdRandom).hide();

                    //show albums
                    window.stopAlbum = false;
                    //jQuerOs(container+" .album-main-image").parent().fadeIn( 2000 );
                    jQuerOs(container+" .album-main-image").parent().show();
                    jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).hide();

                });
            }else{
                jQuerOs(container+" .os-cat-tab-images div:first-child").show();
                jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom+" li:first-child a").addClass("active");
                
                if(osg.params.layout == 'allInOne'){
                    curCatId = jQuerOs(container+" .cat-"+osg.params.galIdRandom).attr('data-cat-id');
                }else{
                    curCatId = jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom+" a.active").attr('data-cat-id');    
                }
                
                
                if(curCatId == undefined){
                    curCatId = 1
                }
                var curEnd = jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom+" a.active").attr('data-end');
                if(curEnd === undefined){
                    curEnd = osg.params.limEnd;
                }
                
                jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-cat-id', curCatId);
                jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end', curEnd);

                if(osg.params.imgCountCat != ''){
                    var img_count_cat = JSON.parse(osg.params.imgCountCat);
                }else{
                    var img_count_cat = '';
                }
                
                if(img_count_cat != '' && jQuerOs('#cat-' + curCatId +'-'+osg.params.galIdRandom).children().length >= img_count_cat[curCatId]){
                    jQuerOs("#load-more-"+osg.params.galIdRandom+"[data-cat-id="+curCatId+"]").hide();
                }else if(img_count_cat != '' && !Array.isArray(img_count_cat) && jQuerOs('#cat-1-'+osg.params.galIdRandom).children().length >= img_count_cat){
                    jQuerOs("#load-more-"+osg.params.galIdRandom).hide();
                }
                if(osg.params.layout == 'masonry'){
                    //fix animate CSS and images appear error for old browsers
                    jQuerOs('.tab-click-loadMore').click(function() {

                       setTimeout(function(){ 
                            osg.reloadIsotope();
                        }, 2000);
                    });  
                }
                if(osg.params.layout != 'allInOne'){
                    jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom+" a").click(function(e) {

                        e.preventDefault();
                        jQuerOs('li a').removeClass("active");
                        jQuerOs(container+" .os-cat-tab-images>div").hide();
                        jQuerOs(this).addClass("active");
                        curCatId = jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom+" a.active").attr('data-cat-id');
                        var href = window.location.href;
                        if (!from_history && href.indexOf('os_image_id') == -1){
                            if (href.indexOf('?cat-') > -1) {

                                history.pushState (null, null, href.substring(0, href.indexOf('?cat-') ) + '?cat-' + curCatId);
                            }else if (href.indexOf('&cat-') > -1) {

                                history.pushState (null, null, href.substring(0, href.indexOf('&cat-') ) + '?cat-' + curCatId);
                            }else if (href.indexOf('?') > -1){

                                history.pushState(null, null, href + '&cat-' + curCatId);
                            }else {

                                history.pushState(null, null, href + '?cat-' + curCatId);
                            }
                        }

                        jQuerOs("#cat-"+curCatId+"-"+osg.params.galIdRandom).show();
                        jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-cat-id', curCatId);
                        curEnd = jQuerOs(container+" .osgalery-cat-tabs#"+osg.params.galIdRandom+" a.active").attr('data-end');
                        if(img_count_cat != '' && jQuerOs('#cat-' + curCatId +'-'+osg.params.galIdRandom).children().length >= Number(img_count_cat[curCatId])){

                            jQuerOs("#load-more-"+osg.params.galIdRandom+"[data-cat-id="+curCatId+"]").hide();
                        }else{

                            jQuerOs("#load-more-"+osg.params.galIdRandom+"[data-cat-id="+curCatId+"]").show();
                        }
                        if(curEnd != -1){
                            jQuerOs("#load-more-"+osg.params.galIdRandom).removeAttr("disabled");
                            jQuerOs("#load-more-"+osg.params.galIdRandom).css("background", osg.params.load_more_background);
                        }
                        jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end', curEnd);
                        jQuerOs(jQuerOs(this).attr("href")).fadeTo(500, 1);

                        if(osg.params.layout == 'masonry'){
                            osg.isotope();
                            osg.reloadIsotope();
                        }else if(osg.params.layout == 'fitRows'){
                            osg.fitRowsIsotope(curCatId);
                        }

                    });
                }else{
                    jQuerOs('.img-block').on('click', function(){
                        //e.preventDefault();
                        jQuerOs('li a').removeClass("active");
                        jQuerOs(this).parent().addClass('active');
                        curCatId = jQuerOs(this).parent().attr('data-cat-id');
                        var href = window.location.href;
                        //???????
                        if (!from_history && href.indexOf('os_image_id') == -1){
                            if (href.indexOf('?cat-') > -1) {

                                history.pushState (null, null, href.substring(0, href.indexOf('?cat-') ) + '?cat-' + curCatId);
                            }else if (href.indexOf('&cat-') > -1) {

                                history.pushState (null, null, href.substring(0, href.indexOf('&cat-') ) + '?cat-' + curCatId);
                            }else if (href.indexOf('?') > -1){

                                history.pushState(null, null, href + '&cat-' + curCatId);
                            }else {

                                history.pushState(null, null, href + '?cat-' + curCatId);
                            }
                        }
                        //????????
                        jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-cat-id', curCatId);
                        curEnd = jQuerOs('a#cat-'+curCatId+osg.params.galIdRandom).attr('data-end');
                        
                        jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end', curEnd);
                        

                    });
                }
            }
            osg.resizeGallery = function (){
                imgBlockW = osg.getImgBlockWidth();
                jQuerOs(container+" .img-block").css("width",imgBlockW+"%");
            }

            jQuerOs(window).resize(function(event) {
                
                if(osg.params.layout == 'masonry' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'masonry')){
                    osg.resizeGallery();
                    if(jQuerOs(window).width() != width){
                        width = jQuerOs(window).width();
                        osg.reloadIsotope();
                    }
                }else if(osg.params.layout == 'fitRows' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'fitRows')){
                    osg.fitRowsIsotope(curCatId);
                }else{
                    osg.resizeGallery();
                }
//                if(osg.params.layout != 'fitRows' && osg.params.layout != 'masonry'){
//                    osg.resizeGallery();
//                }else if(osg.params.layout == 'masonry'){
//                    osg.resizeGallery();
//                    osg.reloadIsotope();
//                }else{
//                    osg.fitRowsIsotope(curCatId);
//                }
            });
            
            if(osg.params.layout == 'masonry' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'masonry')){
                osg.isotope();
            }else if(osg.params.layout == 'fitRows'){
                osg.resizeGallery();
                osg.fitRowsIsotope(curCatId);
            }

        }
        osg.init();
        //VlaDOS 25.09.2020
        //This line was added in 2018 or 2019 to fix the Masonry Layout error on iPhone 4. 
        //Commented on 09/25/2020 to fix the error of framing the first image in the Fitrow Layout
//        setTimeout(osg.resizeGallery, 200);
        //VlaDOS end

        //function for load more Thumbnail
        osg.LoadMoreThumbs = function(data){
            
        var showImgTitle = osg.params.showImgTitle;
        var showImgDescription = osg.params.showImgDescription;
        for(index = 0; index < data.os_loadMore_result.length; ++index){

            var imgParams = JSON.parse(decodeURIComponent(data.os_loadMore_result[index].params));

            var os_caption = "";
            if (data.os_loadMore_result[index].params){
                if(showImgTitle == 1 && imgParams['imgTitle'] != undefined){
                    var os_imgTitle = imgParams['imgTitle'] + '<br>';
                }else{
                    var os_imgTitle = '';
                }
                if(showImgDescription == 1 && imgParams['imgShortDescription'] != undefined){
                    var os_imgShortDescription = imgParams['imgShortDescription'];
                }else{
                    var os_imgShortDescription = '';
                }
                var os_imgHtml = imgParams['imgHtml'];

                os_caption = os_imgTitle + os_imgShortDescription;

            }
            //get youtube link
            var videoLink = imgParams['videoLink'];
            if(videoLink != undefined && videoLink.indexOf('youtu') > -1){
                var os_youtube_link = videoLink.substr(videoLink.indexOf('=')+1)
            }
            //get vimeo link
            if (videoLink != undefined && videoLink.indexOf('vimeo') > -1){
                var os_vimeo_link = videoLink.substr(videoLink.lastIndexOf('/')+1);
            }

            //create a new object <li>

            var img_index = jQuerOs(".os_fancybox-thumbs ul li:last").attr("data-index");

            li_cloned = jQuerOs(".os_fancybox-thumbs ul li:first").clone();


            if(document.getElementsByClassName('os_fancybox-thumbs-x').length > 0){

                ul_stile = jQuerOs(".os_fancybox-thumbs ul");
                ul_stile = ul_stile.attr('style');
                ul_new_style = Number(ul_stile.substring(7, ul_stile.lastIndexOf('px'))) + 108;
                jQuerOs(".os_fancybox-thumbs ul").attr('style', 'width: ' + ul_new_style + 'px;');
            }

//                        var img_index = li_cloned.attr("data-index");

            li_cloned.attr("data-index", ++img_index);
            li_cloned.attr("class", "");
            li_cloned.find('img').attr("src", osg.params.juri + "/images/com_osgallery/gal-" + osg.params.galId + "/thumbnail/"+data.os_loadMore_result[index].file_name);
            li_cloned.find('img').attr("data-src", osg.params.juri + "/images/com_osgallery/gal-" + osg.params.galId + "/thumbnail/"+data.os_loadMore_result[index].file_name);

            li_cloned.appendTo(".os_fancybox-thumbs ul");
            os_fancy_box_getInst = jQuerOs.os_fancybox.getInstance();
            os_fb_group_count = os_fancy_box_getInst.group.length;

            //create a new object slide

            os_fancy_box_group_item_tmp = Object.assign({}, os_fancy_box_getInst.group[os_fb_group_count-1]);

            os_fancy_box_group_item_tmp.index = os_fb_group_count;
            os_fancy_box_group_item_tmp.os_image_id = 'os_image_id-'+data.os_loadMore_result[index].id;
            if (videoLink != undefined && videoLink.indexOf('youtu') > -1){
                os_fancy_box_group_item_tmp.src = '//www.youtube.com/embed/'+ os_youtube_link + '?autoplay=1&autohide=1&fs=1&rel=0&hd=1&wmode=transparent&enablejsapi=1&html5=1';
                os_fancy_box_group_item_tmp.type = 'iframe';
            }
            else if (videoLink != undefined && videoLink.indexOf('vimeo') > -1){
                os_fancy_box_group_item_tmp.src = '//player.vimeo.com/video/'+ os_vimeo_link + '?autoplay=1&hd=1&show_title=1&show_byline=1&show_portrait=0&fullscreen=1&api=1';
                os_fancy_box_group_item_tmp.type = 'iframe';
            }
            else if (os_imgHtml != undefined && os_imgHtml['html'].length > 0){
                os_fancy_box_group_item_tmp.src = '#data-html-'+data.os_loadMore_result[index].id;
                os_fancy_box_group_item_tmp.type = 'inline';
            }    

            else {
                var images = jQuerOs('.img-block a');
                var ind = 0
                while(images.length > ind){
                    var src = jQuerOs(images[ind]).attr('href');
                    // console.log('11111111111', src);
                    if(src != undefined && src.indexOf(data.os_loadMore_result[index].file_name) > -1){
                        os_fancy_box_group_item_tmp.src = src;
                    }
                    ind++;
                }
                
                //os_fancy_box_group_item_tmp.src = osg.params.juri + '/images/com_osgallery/gal-' + osg.params.galId + '/original/'+data.os_loadMore_result[index].file_name;
                os_fancy_box_group_item_tmp.type = 'image';
            }

            if (os_caption){

                os_fancy_box_group_item_tmp.caption = os_caption;
            }
            else {
                os_fancy_box_group_item_tmp.caption = '';
            }

            os_fancy_box_getInst.group.push( os_fancy_box_group_item_tmp );

        }


        jQuerOs(".os_fancybox-button--arrow_right").removeAttr('disabled');
        jQuerOs(".os_fancybox-button--arrow_left").removeAttr('disabled');
        jQuerOs(".os_fancybox-loading").remove();

    }

        osg.loadMore = function(loadMoreType){



            limEnd = osg.params.limEnd;


            if(loadMoreType == '0'){
                return;
            }

            if(loadMoreType == 'button'){
                osg.loadMoreButton();
            }

            if(loadMoreType == 'scroll'){
                osg.loadMoreScroll(false);
                jQuerOs(window).scroll(osg.loadMoreScroll)
            }

            if(loadMoreType == 'auto'){
                osg.loadMoreAuto();
            }
        }


        // add load more script
        osg.loadMoreButton = function(){
            
            if(osg.params.layout == 'search'){
                var task = 'loadMoreButtonSearch';
            }else{
                var task = 'loadMoreButton';
            }
            jQuerOs("#load-more-"+osg.params.galIdRandom).unbind('click');
            
            if(!inProgressAjax ){
            jQuerOs("#load-more-"+osg.params.galIdRandom).on("click", function() {

                inProgressAjax  = true;
                //hide load more/show progress image
                jQuerOs("#load-more-"+osg.params.galIdRandom).css('display', 'none');
                jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'block');


                jQuerOs("#load-more-"+osg.params.galIdRandom).attr('disabled','disabled');
                var href = window.location.href;
                //load more the image in a direct link
                var os_one_img = "";
                //jQuerOs.os_fancybox.getInstance() Determines whether the modal window is running

                if (jQuerOs.os_fancybox.getInstance() == false && href.indexOf('os_image_id') > -1){
                    //get the id of the required picture
                    var leight1 = href.indexOf('os_image_id');
                    var leight2 = href.lastIndexOf('#');
                    if (leight1 > -1 && leight2 > - 1) {
                        var os_one_img = href.substring(leight1, leight2); 
                    }else if(leight1 > -1 && leight2 == -1){
                        var os_one_img = href.substring(leight1);
                    }
                    var os_one_img = os_one_img.substring(12);

                }
                
                jQuerOs.ajax({
                    dataType: "json",
                    type: 'POST',
                    url: osg.params.juri+'/index.php?option=com_osgallery&format=raw',
                    data: {
                        task: task,
                        Itemid: osg.params.itemId,
                        end: jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end'),
                        catId: jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-cat-id'),
                        galId: osg.params.galId,
                        oneimg: os_one_img,
                        moduleId: osg.params.modId,
                        searchText: osg.params.searchText,
                    },
                    beforeSend: function() {
                        inProgressAjax  = true;
                    },
                    success: function(data){
//                        if(osg.params.layout == 'allInOne'){
//                            if(data.success){
//                                //append hidden data
//                                if (jQuerOs.os_fancybox.getInstance() !== false){
//                                    osg.LoadMoreThumbs(data);
//                                }
//                                limEnd = data.limEnd;
//                                jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+", #load-more-"+osg.params.galIdRandom).attr('data-end', data.limEnd);
//                                osg.reinit(data.catId, limEnd);
//                                jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'none');
//                                inProgressAjax  = false;
//                            }
//                        }else{
                            if(data.success){
                                //append hidden data
                                if(osg.params.layout == 'album'){
                                    jQuerOs("#cat-"+data.catId+"-"+osg.params.galIdRandom+" .grid").append(data.html);
                                }else{
                                    jQuerOs("#cat-"+data.catId+"-"+osg.params.galIdRandom).append(data.html);
                                }
                                var lm = 0;

                                    jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden img").load(function(event){
                                        
                                        lm++;
                                        var count = jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden img").length;

                                        //show when all of images are loaded    
                                        if(lm == count){
                                            
                                            if(osg.params.layout != 'allInOne'){
                                                jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+", #load-more-"+osg.params.galIdRandom).attr('data-end', data.limEnd);
                                            }else{
                                                jQuerOs("#cat-"+ data.catId+osg.params.galIdRandom+", #load-more-"+osg.params.galIdRandom).attr('data-end', data.limEnd);
                                            }
                                            jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden").removeClass("load-more-hidden");
                                            

                                            limEnd = data.limEnd;
                                            
                                            if(osg.params.layout == 'masonry' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'masonry')){
                                                osg.reloadAfterLazyLoad();
                                                osg.reloadIsotope();
                                            }else if(osg.params.layout == 'fitRows' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'fit_rows')){
                                                osg.fitRowsIsotope(data.catId);
                                            }else{
                                                osg.resizeGallery();
                                            }
                                            
                                            osg.reinit(data.catId, limEnd);
                                            
                                            if (jQuerOs.os_fancybox.getInstance() !== false){
                                                osg.LoadMoreThumbs(data);
                                            }

                                            if(data.limEnd == -1){
                                                jQuerOs("#load-more-"+osg.params.galIdRandom).attr("disabled","disabled");
                                                jQuerOs("#load-more-"+osg.params.galIdRandom).css("background", "#808080");
                                            }else{
                                                jQuerOs("#load-more-"+osg.params.galIdRandom).removeAttr('disabled');
                                            }
                                            
                                            //go to the picture by a direct link
                                            if (data.os_oneImgId){
                                                var img_el_id = '';
                                                var pos1 = href.indexOf('os_image_id'); 
                                                var pos2 = href.lastIndexOf('#'); 

                                                if (pos1 > -1 && pos2 > - 1) {
                                                    img_el_id = href.substring(pos1, pos2); 
                                                }else if(pos1 > -1 && pos2 == -1){
                                                    img_el_id = href.substring(pos1);
                                                }
                                                if(document.getElementById(img_el_id) !== null){
                                                    jQuerOs('#' + img_el_id).trigger('click');
                                                }
                                            }
                                            
                                            //show load more/hide progress image
                                            if(osg.params.layout != 'allInOne'){
                                                jQuerOs("#load-more-"+osg.params.galIdRandom).css('display', 'block');
                                            }
                                            jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'none');
                                            inProgressAjax  = false;
                                            
                                        }

                                    });



                            }
                        //}
                    },
                    error:function(){
                        inProgressAjax = false;
                    }
                })
            });
            }
        }

        //load more by scroll
        osg.loadMoreScroll = function(){
            if(osg.params.layout == 'search'){
                var task = 'loadMoreScrollSearch';
            }else{
                var task = 'loadMoreScroll';
            }
            jQuerOs("#load-more-"+osg.params.galIdRandom).hide();
            var href = window.location.href;
            
            if(osg.params.layout == 'album'){
                if(href.indexOf('cat-') > -1){
                    var scrollPoint = jQuerOs('.scrollPoint_'+osg.params.galIdRandom).offset();
                }else{
                    var scrollPoint = '';
                }
            }else{
                var scrollPoint = jQuerOs('.scrollPoint_'+osg.params.galIdRandom).offset();
            }
            
            if(limEnd != -1 && !inProgressAjax && (jQuerOs(window).scrollTop() + jQuerOs(window).height()) > (scrollPoint.top)){
                inProgressAjax = true;
                jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'block');
                jQuerOs.ajax({
                    dataType: "json",
                    type: 'POST',
                    url: osg.params.juri+'/index.php?option=com_osgallery&format=raw',
                    data: {
                        task: task,
                        Itemid: osg.params.itemId,
                        end: jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end'),
                        catId: jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-cat-id'),
                        galId: osg.params.galId,
                        moduleId: osg.params.modId,
                        searchText: osg.params.searchText,
                    },
                    beforeSend: function() {
                        inProgressAjax = true;
                    },
                    success: function(data){
                        
                        if(data.success){
                                //append hidden data
                                if(osg.params.layout == 'album'){
                                    jQuerOs("#cat-"+data.catId+"-"+osg.params.galIdRandom + " .grid").append(data.html);
                                }else{
                                    jQuerOs("#cat-"+data.catId+"-"+osg.params.galIdRandom).append(data.html);
                                }
                                if(jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden img").length <= 0){
                                    jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'none');
                                    inProgressAjax = false;
                                }
                                var lm = 0;
                                jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden img").load(function(event){
                                    lm++;
                                    var count = jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden img").length;
                                       
                                    //show when all of images are loaded    
                                    if(lm == count){
                                        if(osg.params.layout == 'masonry'){
                                            jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden").css('position', 'absolute');
                                            jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden").css('bottom', '0px');
                                        }
                                        jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden").removeClass("load-more-hidden");
                                        if(osg.params.layout != 'allInOne'){
                                            jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+", #load-more-"+osg.params.galIdRandom).attr('data-end', data.limEnd);
                                        }else{
                                            jQuerOs("#cat-"+ data.catId+osg.params.galIdRandom+", #load-more-"+osg.params.galIdRandom).attr('data-end', data.limEnd);
                                        }
                                        //jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+", #load-more-"+osg.params.galIdRandom).attr('data-end', data.limEnd);
                                        if(data.limEnd == -1)
                                            jQuerOs("#load-more-"+osg.params.galIdRandom).attr("disabled","disabled");
                                        limEnd = data.limEnd;
                                        if(osg.params.layout == 'masonry' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'masonry')){
                                            osg.reloadAfterLazyLoad();
                                        }else if(osg.params.layout == 'fitRows' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'fit_rows')){
                                            osg.fitRowsIsotope(data.catId);
                                        }else{
                                            osg.resizeGallery();
                                        }
                                        osg.reinit(data.catId, limEnd);
                                        jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'none');
                                        inProgressAjax = false;

                                        osg.loadMoreScroll();
                                    }
                                });
                        }
                    },
                    error:function(){
                        inProgressAjax = false;
                        jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'none');
                        limEnd = -1;
                    }
                })
            }
        };

        //load more by auto
        osg.loadMoreAuto = function(){
            if(osg.params.layout == 'search'){
                var task = 'loadMoreAutoSearch';
            }else{
                var task = 'loadMoreAuto';
            }
            
            jQuerOs("#load-more-"+osg.params.galIdRandom).hide();
            if(limEnd != -1 && !inProgressAjax){
                inProgressAjax = true;

                jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'block');
                jQuerOs.ajax({
                    dataType: "json",
                    type: 'POST',
                    url: osg.params.juri+'/index.php?option=com_osgallery&format=raw',
                    data: {
                        task: task,
                        Itemid: osg.params.itemId,
                        end: jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-end'),
                        catId: jQuerOs("#load-more-"+osg.params.galIdRandom).attr('data-cat-id'),
                        galId: osg.params.galId,
                        moduleId: osg.params.modId,
                        searchText: osg.params.searchText,
                    },
                    beforeSend: function() {
                        inProgressAjax = true;
                    },
                    success: function(data){ 
                        if(data.success){ 
                                //append hidden data

                                if(osg.params.layout == 'album'){
                                    jQuerOs("#cat-"+data.catId+"-"+osg.params.galIdRandom + " .grid").append(data.html);
                                }else{
                                    jQuerOs("#cat-"+data.catId+"-"+osg.params.galIdRandom).append(data.html);
                                }
                                
                                if(jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden img").length <= 0){
                                    jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'none');
                                    inProgressAjax = false;
                                }
                                var lm = 0;
                                jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden img").load(function(event){
                                    lm++;
                                    var count = jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden img").length;

                                    //show when all of images are loaded    
                                    if(lm == count){
                                        if(osg.params.layout == 'masonry'){
                                            jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden").css('position', 'absolute');
                                            jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden").css('bottom', '0px');
                                        }
                                        jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+" .load-more-hidden").removeClass("load-more-hidden");
                                        jQuerOs("#cat-"+ data.catId+"-"+osg.params.galIdRandom+", #load-more-"+osg.params.galIdRandom).attr('data-end', data.limEnd);
                                        if(data.limEnd == -1)
                                            jQuerOs("#load-more-"+osg.params.galIdRandom).attr("disabled","disabled");
                                        limEnd = data.limEnd;
                                        if(osg.params.layout == 'masonry' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'masonry')){
                                            osg.reloadAfterLazyLoad();
                                        }else if(osg.params.layout == 'fitRows' || (osg.params.layout == 'album' && osg.params.albumSublayout == 'fit_rows')){
                                            osg.fitRowsIsotope(data.catId);
                                        }else{
                                            osg.resizeGallery();
                                        }
                                        osg.reinit(data.catId, limEnd);
                                        
                                        if (jQuerOs.os_fancybox.getInstance() !== false){
                                            osg.LoadMoreThumbs(data);
                                        }

                                        var href = window.location.href;
                                        if (jQuerOs.os_fancybox.getInstance() == false && href.indexOf('os_image_id') > -1){
                                            var img_el_id = '';
                                            var pos1 = href.indexOf('os_image_id'); 
                                            var pos2 = href.lastIndexOf('#'); 

                                            if (pos1 > -1 && pos2 > - 1) {
                                                img_el_id = href.substring(pos1, pos2); 
                                            }else if(pos1 > -1 && pos2 == -1){
                                                img_el_id = href.substring(pos1);
                                            }
                                            if(document.getElementById(img_el_id) !== null){
                                                jQuerOs('#' + img_el_id).trigger('click');
                                            }
                                        }

                                        jQuerOs('#os_lm_progres_img-'+osg.params.galIdRandom+':last' ).css('display', 'none');
                                        inProgressAjax = false;
//                                        setTimeout(function(){ 
                                            osg.loadMoreAuto();
//                                        }, 2000);
                                        
                                    }
                                });

                        }
                    },
                    error:function(){
                        inProgressAjax = false;
                        // osg.loadMoreAuto();
                    }
                })  
            }
        }

    }
    window.osGallery = osGallery;
})();